program TEST_RS232;

{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = mega88, VCC=5;
{ $BOOTRST $00C00}         {Reset Jump to $00C00}

Define_Fuses
//  Override_Fuses;
  NoteBook   = A;
  COMport    = USB;
  LockBits0 = [];
  FuseBits0  = [CKSEL0, CKSEL2, CKSEL3];  // Horloge interne 8 MHz
  FuseBits1  = [];
  FuseBits2  = [];

Import SysTick, SerPort, LCDport, ADCPort;



From System Import Float;


Define
  ProcClock      = 8000000;        {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0032, iData;
  FrameSize      = $0032, iData;
  SerPort        = 9600, Stop1;    {Baud, StopBits|Parity}
  RxBuffer       = 100, iData;
  TxBuffer       = 100, iData;
  LCDport        = PortB,0,PortB,4;
  LCDtype        = 44780;
  LCDrows        = 4;              {rows}
  LCDcolumns     = 20;             {columns per line}
  ADCchans       = [6], iData;
  ADCpresc       = 128;

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
var

// Entres boutons poussoirs
   BP1[@PinC, 2] : bit;    // Bouton poussoir
   BP2[@PinC, 1] : bit;    // Bouton poussoir
   BP3[@PinC, 0] : bit;    // Bouton poussoir

// Gestion des boutons poussoirs, bit de mmorisation, bit d'appui
   BP : byte;
   BP1_mem[@BP, 0]   : bit;
   BP1_appui[@BP, 1] : bit;
   BP2_mem[@BP, 2]   : bit;
   BP2_appui[@BP, 3] : bit;
   BP3_mem[@BP, 4]   : bit;
   BP3_appui[@BP, 5] : bit;

// Pour le convertisseur ADC
ADC_Channel : word;
ADC_Low[@ADC_Channel] : byte;
ADC_Hi[@ADC_Channel+1] : byte;
ADC_Channel_Integer : integer absolute ADC_Channel;

   
// Variables diverses
i : byte;
Receive : byte;
Count : byte;

{--------------------------------------------------------------}
{ functions }

procedure InitPorts;
begin
  PortC:= %00000111;
end InitPorts;


procedure TestBP;
begin
   if ( not(BIT(BP1)) and BIT(BP1_mem) )
      then BP1_appui:=true;
      else BP1_appui:=false;
   endif;
   BP1_mem := BP1;

   if ( not(BIT(BP2)) and BIT(BP2_mem) )
      then BP2_appui:=true;
      else BP2_appui:=false;
   endif;
   BP2_mem := BP2;
   
   if ( not(BIT(BP3)) and BIT(BP3_mem) )
      then BP3_appui:=true;
      else BP3_appui:=false;
   endif;
   BP3_mem := BP3;
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  InitPorts;
  EnableInts;
  Count := 0;
  
  LcdXY(0,0);
  Write(LcdOut,'      AVRco      ');
  LcdXY(0,1);
  Write(LcdOut,'   ELAB Computer    ');
  mDelay(200);

  for i:=0 to 19 do
  LcdXY(i,3);Write(LcdOut,'*');
  mDelay(50);
  endfor;
  LcdClr;
  Write(LcdOut,'ESSAI LIAISON  SERIE');
  LcdXY(0,1);
  Write(LcdOut,'P.G Vox         V1.0');
  mDelay(2000);
  LcdClr;

  LcdXY(0,2);
  Write(LcdOut,'Caracteres recus');
          
  loop
      TestBP;
  

      ADC_Channel := GetAdc and $3FF;
      LcdXY(0,0); Write(LCDout, 'VCAN: '+IntToStr(ADC_Channel_Integer:4)+
             ' =>'+FloatToStr((Float(ADC_Channel)*4.8828125e-03):6:4)+'V');


      if (BIT(BP1_appui)) then
         LcdXY(0,3);
         Write(LcdOut,'                    ');
         Count:=0;
      endif;

      if (BIT(BP2_appui)) then
         LcdXY(0,1);
         Write(LcdOut,'Envoi Bonjour ');
         SerOUT('B');SerOUT('o');SerOUT('n');SerOUT('j');
         SerOUT('o');SerOUT('u');SerOUT('r');
         mDelay(2000);
         LcdXY(0,1);
         Write(LcdOut,'                    ');
      endif;


      if (BIT(BP3_appui)) then
         LcdXY(0,1);
         Write(LcdOut,'Envoi CAN');SerOUT(ADC_Hi);SerOUT(ADC_Low);
         mDelay(2000);
         LcdXY(0,1);
         Write(LcdOut,'                    ');
      endif;


      if SerStat then
         Receive:=Serinp;
         LcdXY(Count,3);
         Write(LcdOut,Receive);
         Count:=Count+1;
         if (Count=20)  then
            mDelay(1000);
            LcdXY(0,3);
            Write(LcdOut,'                    ');
            Count:=0;
         endif;

      endif;
      
  endloop;
end TEST_RS232.

